
#include <stdio.h>
#include <time.h>
#include <sys/time.h>
#include <getopt.h>

int
main(argc, argv)
int argc;
char *argv[];
{
   struct tm from, to;
   time_t fromtime, totime;
   char buf[10];
   char *From = NULL, *To = NULL;
   char *cp;
   long diff;
   int i;
   
   while((i = getopt(argc, argv, "f:t:")) != EOF) {
      switch(i) {
      case 'f':
         From = optarg;
         break;
      case 't':
         To = optarg;
         break;
      default:
         exit(1);
      }
   }
   
   if(From == NULL || strlen(From) != 10)
      exit(2);

   if(To == NULL || strlen(To) != 10)
      exit(2);

   for(cp = From; *cp && isdigit(*cp); cp++)
      ;
   if(*cp)
      exit(3);

   for(cp = To; *cp && isdigit(*cp); cp++)
      ;
   if(*cp)
      exit(3);



   cp = From;
   buf[3] = '\0';

   buf[0] = *cp++; 
   buf[1] = *cp++; 
   from.tm_year = atoi(buf);

   buf[0] = *cp++; 
   buf[1] = *cp++; 
   from.tm_mon = atoi(buf) - 1;

   buf[0] = *cp++; 
   buf[1] = *cp++; 
   from.tm_mday = atoi(buf);

   buf[0] = *cp++; 
   buf[1] = *cp++; 
   from.tm_hour = atoi(buf);

   buf[0] = *cp++; 
   buf[1] = *cp++; 
   from.tm_min = atoi(buf);

   from.tm_sec = 0;
   from.tm_wday = -1;
   from.tm_yday = -1;
   from.tm_isdst = -1;

   if((fromtime = mktime(&from)) == -1)
      exit(4);


   cp = To;
   buf[3] = '\0';

   buf[0] = *cp++; 
   buf[1] = *cp++; 
   to.tm_year = atoi(buf);

   buf[0] = *cp++; 
   buf[1] = *cp++; 
   to.tm_mon = atoi(buf) - 1;

   buf[0] = *cp++; 
   buf[1] = *cp++; 
   to.tm_mday = atoi(buf);

   buf[0] = *cp++; 
   buf[1] = *cp++; 
   to.tm_hour = atoi(buf);

   buf[0] = *cp++; 
   buf[1] = *cp++; 
   to.tm_min = atoi(buf);

   to.tm_sec = 0;
   to.tm_wday = -1;
   to.tm_yday = -1;
   to.tm_isdst = -1;

   if((totime = mktime(&to)) == -1)
      exit(4);

   diff = totime - fromtime;
   
   fprintf(stdout, "%ld\n", diff);
   fflush(stdout);	/* PARANOIA! **/
   
   exit(0);
}
